"use client";
import {
  useNavbarContext
} from "./chunk-RIK2MKOP.mjs";
import {
  menuItemVariants
} from "./chunk-UGV7KSPT.mjs";

// src/navbar-menu-item.tsx
import { forwardRef } from "@nextui-org/system";
import { useDOMRef } from "@nextui-org/dom-utils";
import { clsx, dataAttr } from "@nextui-org/shared-utils";
import { motion } from "framer-motion";
import { mergeProps } from "@react-aria/utils";
import { jsx } from "react/jsx-runtime";
var NavbarMenuItem = forwardRef((props, ref) => {
  var _a, _b;
  const { className, children, disableAnimation, motionProps, ...otherProps } = props;
  const domRef = useDOMRef(ref);
  const { slots, isMenuOpen, classNames } = useNavbarContext();
  const styles = clsx(classNames == null ? void 0 : classNames.menuItem, className);
  if (disableAnimation) {
    return /* @__PURE__ */ jsx(
      "li",
      {
        ref: domRef,
        className: (_a = slots.menuItem) == null ? void 0 : _a.call(slots, { class: styles }),
        "data-open": dataAttr(isMenuOpen),
        ...otherProps,
        children
      }
    );
  }
  return /* @__PURE__ */ jsx(
    motion.li,
    {
      ref: domRef,
      className: (_b = slots.menuItem) == null ? void 0 : _b.call(slots, { class: styles }),
      "data-open": dataAttr(isMenuOpen),
      variants: menuItemVariants,
      ...mergeProps(motionProps, otherProps),
      children
    }
  );
});
NavbarMenuItem.displayName = "NextUI.NavbarMenuItem";
var navbar_menu_item_default = NavbarMenuItem;

export {
  navbar_menu_item_default
};
