"use client";
import {
  useNavbarContext
} from "./chunk-RIK2MKOP.mjs";
import {
  menuVariants
} from "./chunk-UGV7KSPT.mjs";

// src/navbar-menu.tsx
import { forwardRef } from "@nextui-org/system";
import { useDOMRef } from "@nextui-org/dom-utils";
import { clsx, dataAttr } from "@nextui-org/shared-utils";
import { motion } from "framer-motion";
import { usePreventScroll } from "@react-aria/overlays";
import { mergeProps } from "@react-aria/utils";
import { jsx } from "react/jsx-runtime";
var NavbarMenu = forwardRef((props, ref) => {
  var _a, _b;
  const { className, children, disableAnimation = false, motionProps, ...otherProps } = props;
  const domRef = useDOMRef(ref);
  const { slots, isMenuOpen, classNames } = useNavbarContext();
  const styles = clsx(classNames == null ? void 0 : classNames.menu, className);
  usePreventScroll({
    isDisabled: !isMenuOpen
  });
  if (disableAnimation) {
    return /* @__PURE__ */ jsx(
      "ul",
      {
        ref: domRef,
        className: (_a = slots.menu) == null ? void 0 : _a.call(slots, { class: styles }),
        "data-open": dataAttr(isMenuOpen),
        ...otherProps,
        children
      }
    );
  }
  return /* @__PURE__ */ jsx(
    motion.ul,
    {
      ref: domRef,
      layoutScroll: true,
      animate: isMenuOpen ? "open" : "closed",
      className: (_b = slots.menu) == null ? void 0 : _b.call(slots, { class: styles }),
      "data-open": dataAttr(isMenuOpen),
      initial: false,
      variants: menuVariants,
      ...mergeProps(motionProps, otherProps),
      children
    }
  );
});
NavbarMenu.displayName = "NextUI.NavbarMenu";
var navbar_menu_default = NavbarMenu;

export {
  navbar_menu_default
};
