"use client";
"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/navbar-menu.tsx
var navbar_menu_exports = {};
__export(navbar_menu_exports, {
  default: () => navbar_menu_default
});
module.exports = __toCommonJS(navbar_menu_exports);
var import_system = require("@nextui-org/system");
var import_dom_utils = require("@nextui-org/dom-utils");
var import_shared_utils2 = require("@nextui-org/shared-utils");
var import_framer_motion = require("framer-motion");
var import_overlays = require("@react-aria/overlays");
var import_utils = require("@react-aria/utils");

// src/navbar-menu-transitions.ts
var menuVariants = {
  open: {
    transition: {
      type: "spring",
      bounce: 0,
      duration: 0.7,
      delayChildren: 0.15,
      staggerChildren: 0.05
    }
  },
  closed: {
    transition: {
      type: "spring",
      bounce: 0,
      duration: 0.3
    }
  }
};

// src/navbar-context.ts
var import_shared_utils = require("@nextui-org/shared-utils");
var [NavbarProvider, useNavbarContext] = (0, import_shared_utils.createContext)({
  name: "NavbarContext",
  strict: true,
  errorMessage: "useNavbarContext: `context` is undefined. Seems you forgot to wrap component within <Navbar />"
});

// src/navbar-menu.tsx
var import_jsx_runtime = require("react/jsx-runtime");
var NavbarMenu = (0, import_system.forwardRef)((props, ref) => {
  var _a, _b;
  const { className, children, disableAnimation = false, motionProps, ...otherProps } = props;
  const domRef = (0, import_dom_utils.useDOMRef)(ref);
  const { slots, isMenuOpen, classNames } = useNavbarContext();
  const styles = (0, import_shared_utils2.clsx)(classNames == null ? void 0 : classNames.menu, className);
  (0, import_overlays.usePreventScroll)({
    isDisabled: !isMenuOpen
  });
  if (disableAnimation) {
    return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
      "ul",
      {
        ref: domRef,
        className: (_a = slots.menu) == null ? void 0 : _a.call(slots, { class: styles }),
        "data-open": (0, import_shared_utils2.dataAttr)(isMenuOpen),
        ...otherProps,
        children
      }
    );
  }
  return /* @__PURE__ */ (0, import_jsx_runtime.jsx)(
    import_framer_motion.motion.ul,
    {
      ref: domRef,
      layoutScroll: true,
      animate: isMenuOpen ? "open" : "closed",
      className: (_b = slots.menu) == null ? void 0 : _b.call(slots, { class: styles }),
      "data-open": (0, import_shared_utils2.dataAttr)(isMenuOpen),
      initial: false,
      variants: menuVariants,
      ...(0, import_utils.mergeProps)(motionProps, otherProps),
      children
    }
  );
});
NavbarMenu.displayName = "NextUI.NavbarMenu";
var navbar_menu_default = NavbarMenu;
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
